Index: trunk/src/kernel32/KERNEL32.CPP
===================================================================
--- trunk/src/kernel32/KERNEL32.CPP	(revision 5307)
+++ trunk/src/kernel32/KERNEL32.CPP	(revision 5308)
@@ -1,3 +1,3 @@
-/* $Id: KERNEL32.CPP,v 1.58 2001-01-23 18:31:25 sandervl Exp $ */
+/* $Id: KERNEL32.CPP,v 1.59 2001-03-13 18:45:32 sandervl Exp $ */
 
 /*
@@ -32,5 +32,4 @@
 
 #include "misc.h"
-#include <builtin.h>
 #include "heap.h"
 #include "handlemanager.h"
Index: trunk/src/kernel32/async.cpp
===================================================================
--- trunk/src/kernel32/async.cpp	(revision 5307)
+++ trunk/src/kernel32/async.cpp	(revision 5308)
@@ -1,3 +1,3 @@
-/* $Id: async.cpp,v 1.9 2000-09-15 13:24:29 sandervl Exp $ */
+/* $Id: async.cpp,v 1.10 2001-03-13 18:45:32 sandervl Exp $ */
 
 /*
@@ -36,5 +36,4 @@
 #define  INCL_AVIO
 #include <os2wrap.h>	//Odin32 OS/2 api wrappers
-#include <builtin.h>
 
 #include <stdlib.h>
Index: trunk/src/kernel32/conout.cpp
===================================================================
--- trunk/src/kernel32/conout.cpp	(revision 5307)
+++ trunk/src/kernel32/conout.cpp	(revision 5308)
@@ -1,3 +1,3 @@
-/* $Id: conout.cpp,v 1.9 2001-01-23 18:31:25 sandervl Exp $ */
+/* $Id: conout.cpp,v 1.10 2001-03-13 18:45:32 sandervl Exp $ */
 
 /*
@@ -58,5 +58,4 @@
 #define  INCL_AVIO
 #include <os2wrap.h>	//Odin32 OS/2 api wrappers
-#include <builtin.h>
 #include <stdlib.h>
 #include <string.h>
Index: trunk/src/kernel32/conprop.cpp
===================================================================
--- trunk/src/kernel32/conprop.cpp	(revision 5307)
+++ trunk/src/kernel32/conprop.cpp	(revision 5308)
@@ -1,3 +1,3 @@
-/* $Id: conprop.cpp,v 1.10 2000-02-16 14:25:32 sandervl Exp $ */
+/* $Id: conprop.cpp,v 1.11 2001-03-13 18:45:32 sandervl Exp $ */
 
 /*
@@ -33,5 +33,4 @@
 #define  INCL_AVIO
 #include <os2wrap.h>    //Odin32 OS/2 api wrappers
-#include <builtin.h>
 
 #include <stdlib.h>
Index: trunk/src/kernel32/conprop2.cpp
===================================================================
--- trunk/src/kernel32/conprop2.cpp	(revision 5307)
+++ trunk/src/kernel32/conprop2.cpp	(revision 5308)
@@ -1,3 +1,3 @@
-/* $Id: conprop2.cpp,v 1.6 2000-03-03 11:15:57 sandervl Exp $ */
+/* $Id: conprop2.cpp,v 1.7 2001-03-13 18:45:33 sandervl Exp $ */
 
 /*
@@ -37,5 +37,4 @@
 #define  INCL_AVIO
 #include <os2wrap.h>    //Odin32 OS/2 api wrappers
-#include <builtin.h>
 
 #include <win32type.h>
Index: trunk/src/kernel32/console.cpp
===================================================================
--- trunk/src/kernel32/console.cpp	(revision 5307)
+++ trunk/src/kernel32/console.cpp	(revision 5308)
@@ -1,3 +1,3 @@
-/* $Id: console.cpp,v 1.25 2001-02-08 10:23:40 sandervl Exp $ */
+/* $Id: console.cpp,v 1.26 2001-03-13 18:45:33 sandervl Exp $ */
 
 /*
@@ -53,5 +53,4 @@
 *   Header Files                                                               *
 *******************************************************************************/
-#include <builtin.h>
 #include <stdlib.h>
 #include <string.h>
Index: trunk/src/kernel32/exceptions.cpp
===================================================================
--- trunk/src/kernel32/exceptions.cpp	(revision 5307)
+++ trunk/src/kernel32/exceptions.cpp	(revision 5308)
@@ -1,3 +1,3 @@
-/* $Id: exceptions.cpp,v 1.50 2001-02-14 10:36:45 sandervl Exp $ */
+/* $Id: exceptions.cpp,v 1.51 2001-03-13 18:45:33 sandervl Exp $ */
 
 /* WARNING: Compiling this module with ICC with optimizations turned on   */
@@ -62,5 +62,4 @@
 #include <assert.h>
 #include <string.h>
-#include <builtin.h>
 #include "exceptions.h"
 #include "exceptutil.h"
Index: trunk/src/kernel32/initterm.cpp
===================================================================
--- trunk/src/kernel32/initterm.cpp	(revision 5307)
+++ trunk/src/kernel32/initterm.cpp	(revision 5308)
@@ -90,6 +90,5 @@
 /* calling this function.                                                   */
 /****************************************************************************/
-unsigned long SYSTEM _DLL_InitTerm(unsigned long hModule, unsigned long
-                                    ulFlag)
+ULONG DLLENTRYPOINT_CCONV DLLENTRYPOINT_NAME(ULONG hModule, ULONG ulFlag)
 {
     size_t i;
@@ -116,5 +115,5 @@
             char *endofpath = strrchr(kernel32Path, '\\');
             *(endofpath+1) = 0;
-            dprintf(("kernel32 init %s %s", __DATE__, __TIME__));
+            dprintf(("kernel32 init %s %s (%x)", __DATE__, __TIME__, DLLENTRYPOINT_NAME));
             ctordtorInit();
 
Index: trunk/src/kernel32/ordinals.cpp
===================================================================
--- trunk/src/kernel32/ordinals.cpp	(revision 5307)
+++ trunk/src/kernel32/ordinals.cpp	(revision 5308)
@@ -15,5 +15,4 @@
 #include <winnls.h>
 #include "unicode.h"
-#include <builtin.h>
 #include "handlemanager.h"
 #include <string.h>
Index: trunk/src/kernel32/os2heap.cpp
===================================================================
--- trunk/src/kernel32/os2heap.cpp	(revision 5307)
+++ trunk/src/kernel32/os2heap.cpp	(revision 5308)
@@ -1,3 +1,3 @@
-/* $Id: os2heap.cpp,v 1.15 2000-04-30 16:31:47 sandervl Exp $ */
+/* $Id: os2heap.cpp,v 1.16 2001-03-13 18:45:33 sandervl Exp $ */
 
 /*
@@ -18,5 +18,4 @@
 #define  INCL_DOSERRORS
 #include <os2wrap.h>	//Odin32 OS/2 api wrappers
-#include <builtin.h>
 #include <stdlib.h>
 #include <string.h>
Index: trunk/src/kernel32/stubs.cpp
===================================================================
--- trunk/src/kernel32/stubs.cpp	(revision 5307)
+++ trunk/src/kernel32/stubs.cpp	(revision 5308)
@@ -17,5 +17,4 @@
 #include <winnls.h>
 #include "unicode.h"
-#include <builtin.h>
 #include "handlemanager.h"
 #include <string.h>
Index: trunk/src/kernel32/thunk.cpp
===================================================================
--- trunk/src/kernel32/thunk.cpp	(revision 5307)
+++ trunk/src/kernel32/thunk.cpp	(revision 5308)
@@ -1,3 +1,3 @@
-/* $Id: thunk.cpp,v 1.5 2000-03-10 16:12:01 sandervl Exp $ */
+/* $Id: thunk.cpp,v 1.6 2001-03-13 18:45:34 sandervl Exp $ */
 
 /*
@@ -19,5 +19,4 @@
 #include <os2win.h>
 #include <string.h>
-#include <builtin.h>
 #include "thunk.h"
 
Index: trunk/src/kernel32/version.cpp
===================================================================
--- trunk/src/kernel32/version.cpp	(revision 5307)
+++ trunk/src/kernel32/version.cpp	(revision 5308)
@@ -1,3 +1,3 @@
-/* $Id: version.cpp,v 1.2 2000-10-02 18:39:36 sandervl Exp $ */
+/* $Id: version.cpp,v 1.3 2001-03-13 18:45:34 sandervl Exp $ */
 
 /*
@@ -29,8 +29,7 @@
 #include <heapstring.h>
 
-#include "misc.h"
-#include <builtin.h>
+#include <misc.h>
 #include "heap.h"
-#include "handlemanager.h"
+#include <handlemanager.h>
 #include "wprocess.h"
 #include "oslibdos.h"
Index: trunk/src/kernel32/winres.cpp
===================================================================
--- trunk/src/kernel32/winres.cpp	(revision 5307)
+++ trunk/src/kernel32/winres.cpp	(revision 5308)
@@ -1,3 +1,3 @@
-/* $Id: winres.cpp,v 1.28 2000-11-09 18:18:11 sandervl Exp $ */
+/* $Id: winres.cpp,v 1.29 2001-03-13 18:45:34 sandervl Exp $ */
 
 /*
@@ -18,7 +18,4 @@
 #include <os2wrap.h>    //Odin32 OS/2 api wrappers
 #include <stdarg.h>
-#ifdef __IBMCPP__
-#include <builtin.h>
-#endif
 #include <stdio.h>
 #include <stdlib.h>
Index: trunk/src/kernel32/wprocess.cpp
===================================================================
--- trunk/src/kernel32/wprocess.cpp	(revision 5307)
+++ trunk/src/kernel32/wprocess.cpp	(revision 5308)
@@ -1,3 +1,3 @@
-/* $Id: wprocess.cpp,v 1.113 2001-02-09 18:31:06 sandervl Exp $ */
+/* $Id: wprocess.cpp,v 1.114 2001-03-13 18:45:35 sandervl Exp $ */
 
 /*
@@ -31,8 +31,4 @@
 #include <vmutex.h>
 #include <handlemanager.h>
-
-#ifdef __IBMCPP__
-#include <builtin.h>
-#endif
 
 #include "odin32validate.h"