Index: trunk/src/dllentry/dllentry.cpp
===================================================================
--- trunk/src/dllentry/dllentry.cpp	(revision 5308)
+++ trunk/src/dllentry/dllentry.cpp	(revision 5309)
@@ -1,3 +1,3 @@
-/* $Id: dllentry.cpp,v 1.5 2001-02-14 15:14:42 sandervl Exp $ */
+/* $Id: dllentry.cpp,v 1.6 2001-03-13 18:47:12 sandervl Exp $ */
 
 /*
@@ -47,5 +47,5 @@
 //******************************************************************************
 //******************************************************************************
-BOOL WINAPI LibMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID fImpLoad)
+BOOL WINAPI OdinLibMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID fImpLoad)
 {
    switch (fdwReason)
@@ -78,5 +78,5 @@
 /* calling this function.                                                   */
 /****************************************************************************/
-unsigned long SYSTEM _DLL_InitTerm(unsigned long hModule, unsigned long ulFlag)
+ULONG DLLENTRYPOINT_CCONV DLLENTRYPOINT_NAME(ULONG hModule, ULONG ulFlag)
 {
    /*-------------------------------------------------------------------------*/
@@ -91,5 +91,5 @@
          ctordtorInit();
          CheckVersionFromHMOD(PE2LX_VERSION, hModule); /*PLF Wed  98-03-18 05:28:48*/
-         dllHandle = RegisterLxDll(hModule, LibMain, (PVOID)&_Resource_PEResTab);
+         dllHandle = RegisterLxDll(hModule, OdinLibMain, (PVOID)&_Resource_PEResTab);
          if (dllHandle == 0)
             return 0UL;
Index: trunk/src/gdi32/initterm.cpp
===================================================================
--- trunk/src/gdi32/initterm.cpp	(revision 5308)
+++ trunk/src/gdi32/initterm.cpp	(revision 5309)
@@ -46,5 +46,5 @@
 //******************************************************************************
 //******************************************************************************
-BOOL WINAPI LibMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID fImpLoad)
+BOOL WINAPI OdinLibMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID fImpLoad)
 {
    switch (fdwReason)
@@ -71,6 +71,5 @@
 /* calling this function.                                                   */
 /****************************************************************************/
-unsigned long SYSTEM _DLL_InitTerm(unsigned long hModule, unsigned long
-                                   ulFlag)
+ULONG DLLENTRYPOINT_CCONV DLLENTRYPOINT_NAME(ULONG hModule, ULONG ulFlag)
 {
    size_t i;
@@ -93,5 +92,5 @@
 		return 0UL;
          }
-	 dllHandle = RegisterLxDll(hModule, LibMain, (PVOID)&_Resource_PEResTab,
+	 dllHandle = RegisterLxDll(hModule, OdinLibMain, (PVOID)&_Resource_PEResTab,
                                    GDI32_MAJORIMAGE_VERSION, GDI32_MINORIMAGE_VERSION,
                                    IMAGE_SUBSYSTEM_NATIVE);
Index: trunk/src/shell32/initterm.cpp
===================================================================
--- trunk/src/shell32/initterm.cpp	(revision 5308)
+++ trunk/src/shell32/initterm.cpp	(revision 5309)
@@ -46,5 +46,5 @@
 //******************************************************************************
 //******************************************************************************
-BOOL WINAPI LibMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID fImpLoad)
+BOOL WINAPI OdinLibMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID fImpLoad)
 {
  BOOL ret;
@@ -72,6 +72,5 @@
 /* calling this function.                                                   */
 /****************************************************************************/
-unsigned long SYSTEM _DLL_InitTerm(unsigned long hModule, unsigned long
-                                   ulFlag)
+ULONG DLLENTRYPOINT_CCONV DLLENTRYPOINT_NAME(ULONG hModule, ULONG ulFlag)
 {
    size_t i;
@@ -90,5 +89,5 @@
          CheckVersionFromHMOD(PE2LX_VERSION, hModule); /*PLF Wed  98-03-18 05:28:48*/
 
-	 dllHandle = RegisterLxDll(hModule, LibMain, (PVOID)&_Resource_PEResTab, 
+	 dllHandle = RegisterLxDll(hModule, OdinLibMain, (PVOID)&_Resource_PEResTab, 
                                    SHELL32_MAJORIMAGE_VERSION, SHELL32_MINORIMAGE_VERSION,
                                    IMAGE_SUBSYSTEM_WINDOWS_GUI);
Index: trunk/src/winmm/initterm.cpp
===================================================================
--- trunk/src/winmm/initterm.cpp	(revision 5308)
+++ trunk/src/winmm/initterm.cpp	(revision 5309)
@@ -56,5 +56,5 @@
 //******************************************************************************
 //******************************************************************************
-BOOL WINAPI LibMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID fImpLoad)
+BOOL WINAPI OdinLibMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID fImpLoad)
 {
   static BOOL     		bInitDone = FALSE;
@@ -97,6 +97,5 @@
 /* calling this function.                                                   */
 /****************************************************************************/
-unsigned long _System _DLL_InitTerm(unsigned long hModule, unsigned long
-                                    ulFlag)
+ULONG DLLENTRYPOINT_CCONV DLLENTRYPOINT_NAME(ULONG hModule, ULONG ulFlag)
 {
    size_t i;
@@ -117,5 +116,5 @@
          CheckVersionFromHMOD(PE2LX_VERSION, hModule); /*PLF Wed  98-03-18 05:28:48*/
 
-         dllHandle = RegisterLxDll(hModule, LibMain, (PVOID)&_Resource_PEResTab);
+         dllHandle = RegisterLxDll(hModule, OdinLibMain, (PVOID)&_Resource_PEResTab);
          if(dllHandle == 0) 
            return 0UL;/* Error */
Index: trunk/src/wsock32/initterm.cpp
===================================================================
--- trunk/src/wsock32/initterm.cpp	(revision 5308)
+++ trunk/src/wsock32/initterm.cpp	(revision 5309)
@@ -47,5 +47,5 @@
 //******************************************************************************
 //******************************************************************************
-BOOL WINAPI LibMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID fImpLoad)
+BOOL WINAPI OdinLibMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID fImpLoad)
 {
    switch (fdwReason)
@@ -72,6 +72,5 @@
 /* calling this function.                                                   */
 /****************************************************************************/
-unsigned long SYSTEM _DLL_InitTerm(unsigned long hModule, unsigned long
-                                   ulFlag)
+ULONG DLLENTRYPOINT_CCONV DLLENTRYPOINT_NAME(ULONG hModule, ULONG ulFlag)
 {
    size_t i;
@@ -92,5 +91,5 @@
          CheckVersionFromHMOD(PE2LX_VERSION, hModule); /*PLF Wed  98-03-18 05:28:48*/
 
-	 dllHandle = RegisterLxDll(hModule, LibMain, (PVOID)&_Resource_PEResTab);
+	 dllHandle = RegisterLxDll(hModule, OdinLibMain, (PVOID)&_Resource_PEResTab);
          if(dllHandle == 0) 
 		return 0UL;