Index: trunk/src/ddraw/OS2UTIL.CPP
===================================================================
--- trunk/src/ddraw/OS2UTIL.CPP	(revision 5342)
+++ trunk/src/ddraw/OS2UTIL.CPP	(revision 5344)
@@ -1,3 +1,3 @@
-/* $Id: OS2UTIL.CPP,v 1.10 2001-01-02 18:21:39 sandervl Exp $ */
+/* $Id: OS2UTIL.CPP,v 1.11 2001-03-20 23:18:55 mike Exp $ */
 
 /*
@@ -49,5 +49,7 @@
 //******************************************************************************
 
+extern "C" {
 BOOL    APIENTRY _GpiEnableYInversion (HPS hps, LONG lHeight);
+}
 
 void InverseDC(HDC hdc, LONG lHeight)
Index: trunk/src/ddraw/cio2.h
===================================================================
--- trunk/src/ddraw/cio2.h	(revision 5342)
+++ trunk/src/ddraw/cio2.h	(revision 5344)
@@ -10,14 +10,14 @@
 extern "C"
 {
- int io_init1();
- int io_init2(short);
- int io_exit1();
+ int _System io_init1();
+ int _System io_init2(short);
+ int _System _io_exit1();
 
- char c_inb1(short);
- short c_inw1(short);
- long c_inl1(short);
- void c_outb1(short,char);
- void c_outw1(short,short);
- void c_outl1(short,long);
+ char _System c_inb1(short);
+ short _System c_inw1(short);
+ long _System c_inl1(short);
+ void _System c_outb1(short,char);
+ void _System c_outw1(short,short);
+ void _System c_outl1(short,long);
  int psw();
 }
Index: trunk/src/ddraw/ddraw.CPP
===================================================================
--- trunk/src/ddraw/ddraw.CPP	(revision 5342)
+++ trunk/src/ddraw/ddraw.CPP	(revision 5344)
@@ -1,3 +1,3 @@
-/* $Id: ddraw.CPP,v 1.17 2001-03-18 21:44:44 mike Exp $ */
+/* $Id: ddraw.CPP,v 1.18 2001-03-20 23:18:55 mike Exp $ */
 
 /*
@@ -28,4 +28,6 @@
 #include <misc.h>
 
+extern "C" {
+
 //******************************************************************************
 //******************************************************************************
@@ -71,5 +73,5 @@
 
 //******************************************************************************
-typedef BOOL (FAR PASCAL * LPDDENUMCALLBACKA)(GUID FAR *, LPSTR, LPSTR, LPVOID);
+//typedef BOOL (FAR PASCAL * LPDDENUMCALLBACKA)(GUID FAR *, LPSTR, LPSTR, LPVOID);
 //******************************************************************************
 HRESULT WIN32API OS2DirectDrawEnumerateA(LPDDENUMCALLBACKA lpCallback,
@@ -285,2 +287,3 @@
 }//******************************************************************************
 
+}
Index: trunk/src/ddraw/os2fsdd.h
===================================================================
--- trunk/src/ddraw/os2fsdd.h	(revision 5342)
+++ trunk/src/ddraw/os2fsdd.h	(revision 5344)
@@ -11,4 +11,8 @@
 #ifndef __OS2FSDD__
 #define __OS2FSDD__
+
+#ifdef __cplusplus
+extern "C" {
+#endif
 
 ULONG APIENTRY Gre32Entry3(ULONG,ULONG,ULONG);
@@ -43,4 +47,9 @@
 #define GreResurrection(a,b,c) (BOOL) _Gre32Entry5((HDC)(a),(LONG)(b),(c),0L,NGreResurrection)
 
+
+#ifdef __cplusplus
+}
+#endif
+
 ULONG SetSVGAMode (ULONG     ulHorRes,
                    ULONG     ulVerRes,
Index: trunk/src/ddraw/rectangle.cpp
===================================================================
--- trunk/src/ddraw/rectangle.cpp	(revision 5342)
+++ trunk/src/ddraw/rectangle.cpp	(revision 5344)
@@ -1,3 +1,3 @@
-/* $Id: rectangle.cpp,v 1.4 2001-03-18 21:44:46 mike Exp $ */
+/* $Id: rectangle.cpp,v 1.5 2001-03-20 23:18:56 mike Exp $ */
 
 /*
@@ -10,5 +10,5 @@
  */
 
-typedef long BOOL;
+typedef unsigned long BOOL;
 
 #include "rectangle.h"
Index: trunk/src/ddraw/rectangle.h
===================================================================
--- trunk/src/ddraw/rectangle.h	(revision 5342)
+++ trunk/src/ddraw/rectangle.h	(revision 5344)
@@ -1,3 +1,3 @@
-/* $Id: rectangle.h,v 1.5 2001-03-18 21:44:46 mike Exp $ */
+/* $Id: rectangle.h,v 1.6 2001-03-20 23:18:56 mike Exp $ */
 
 /*
@@ -30,6 +30,6 @@
 /*------------------------------- Comparisons --------------------------------*/
 BOOL
-  operator == ( const DDRectangle& rectangle ) const,
-  operator != ( const DDRectangle& rectangle ) const;
+  operator == ( const DDRectangle &rectangle ) const,
+  operator != ( const DDRectangle &rectangle ) const;
 
 /*--------------------------------- Testing ----------------------------------*/