Index: trunk/src/user32/oslibwin.cpp
===================================================================
--- trunk/src/user32/oslibwin.cpp	(revision 5511)
+++ trunk/src/user32/oslibwin.cpp	(revision 5512)
@@ -1,3 +1,3 @@
-/* $Id: oslibwin.cpp,v 1.90 2001-04-05 09:31:27 sandervl Exp $ */
+/* $Id: oslibwin.cpp,v 1.91 2001-04-15 17:05:29 sandervl Exp $ */
 /*
  * Window API wrappers for OS/2
@@ -93,4 +93,5 @@
 }
 //******************************************************************************
+//Note: Also check OSLibSetWindowStyle when changing this!!
 //******************************************************************************
 BOOL OSLibWinConvertStyle(ULONG dwStyle, ULONG dwExStyle, ULONG *OSWinStyle)
@@ -99,8 +100,8 @@
 
   /* Window styles */
+#if 0
+  //Done explicitely in CreateWindowExA
   if(dwStyle & WS_MINIMIZE_W)
         *OSWinStyle |= WS_MINIMIZED;
-//Done explicitely in CreateWindowExA
-#if 0
   if(dwStyle & WS_VISIBLE_W)
         *OSWinStyle |= WS_VISIBLE;
@@ -112,4 +113,5 @@
   if(dwStyle & WS_CLIPCHILDREN_W)
         *OSWinStyle |= WS_CLIPCHILDREN;
+#if 0
   if(dwStyle & WS_MAXIMIZE_W)
         *OSWinStyle |= WS_MAXIMIZED;
@@ -118,4 +120,5 @@
   if(dwStyle & WS_TABSTOP_W)
         *OSWinStyle |= WS_TABSTOP;
+#endif
 
   return TRUE;
@@ -713,18 +716,27 @@
 //******************************************************************************
 //******************************************************************************
-void OSLibSetWindowStyle(HWND hwnd, ULONG dwStyle, ULONG dwExStyle, BOOL saveBits)
-{
-  ULONG dwWinStyle;
-
-  OSLibWinConvertStyle(dwStyle, dwExStyle, &dwWinStyle);
-
-  dwWinStyle = dwWinStyle & ~(WS_TABSTOP | WS_GROUP | WS_CLIPCHILDREN);
-  if(saveBits) dwWinStyle |= WS_SAVEBITS;
-  if(dwStyle & WS_VISIBLE_W)
-        dwWinStyle |= WS_VISIBLE;
-
-  WinSetWindowULong(hwnd, QWL_STYLE,
-                    (WinQueryWindowULong(hwnd, QWL_STYLE) & ~0xffff0000) |
-                     dwWinStyle);
+void OSLibSetWindowStyle(HWND hwnd, ULONG dwStyle, ULONG dwExStyle)
+{
+  ULONG dwWinStyle = WinQueryWindowULong(hwnd, QWL_STYLE);
+  ULONG dwOldWinStyle = dwWinStyle;
+
+  if(dwStyle & WS_DISABLED_W) {
+        dwWinStyle |= WS_DISABLED;
+  }
+  else  dwWinStyle &= ~WS_DISABLED;
+
+  if(dwStyle & WS_CLIPSIBLINGS_W) {
+        dwWinStyle |= WS_CLIPSIBLINGS;
+  }
+  else  dwWinStyle &= ~WS_CLIPSIBLINGS;
+
+  if(dwStyle & WS_CLIPCHILDREN_W) {
+        dwWinStyle |= WS_CLIPCHILDREN;
+  }
+  else  dwWinStyle &= ~WS_CLIPCHILDREN;
+
+  if(dwWinStyle != dwOldWinStyle) {
+      WinSetWindowULong(hwnd, QWL_STYLE, dwWinStyle);
+  }
 }
 //******************************************************************************
Index: trunk/src/user32/oslibwin.h
===================================================================
--- trunk/src/user32/oslibwin.h	(revision 5511)
+++ trunk/src/user32/oslibwin.h	(revision 5512)
@@ -1,3 +1,3 @@
-/* $Id: oslibwin.h,v 1.52 2001-04-05 09:31:27 sandervl Exp $ */
+/* $Id: oslibwin.h,v 1.53 2001-04-15 17:05:29 sandervl Exp $ */
 /*
  * Window API wrappers for OS/2
@@ -43,5 +43,5 @@
 
 BOOL  OSLibWinConvertStyle(ULONG dwStyle, ULONG dwExStyle, ULONG *OSWinStyle);
-void  OSLibSetWindowStyle(HWND hwnd, ULONG dwStyle, BOOL fTaskList);
+void  OSLibSetWindowStyle(HWND hwnd, ULONG dwStyle, ULONG dwExStyle);
 DWORD OSLibQueryWindowStyle(HWND hwnd);
 
Index: trunk/src/user32/win32wbase.cpp
===================================================================
--- trunk/src/user32/win32wbase.cpp	(revision 5511)
+++ trunk/src/user32/win32wbase.cpp	(revision 5512)
@@ -1,3 +1,3 @@
-/* $Id: win32wbase.cpp,v 1.250 2001-04-12 14:04:32 sandervl Exp $ */
+/* $Id: win32wbase.cpp,v 1.251 2001-04-15 17:05:29 sandervl Exp $ */
 /*
  * Win32 Window Base Class for OS/2
@@ -1581,4 +1581,10 @@
       int rc;
 
+        if(getWindowHandle() == 0x68000044) {
+          rc = GetClipBox( (HDC)wParam, &rect );
+          FillRect( (HDC)wParam, &rect, GetSysColorBrush(COLOR_WINDOWTEXT));
+          return 1;
+        }
+       
         if (!windowClass || !windowClass->getBackgroundBrush()) return 0;
 
@@ -3443,6 +3449,5 @@
                 setStyle(ss.styleNew);
                 SendInternalMessageA(WM_STYLECHANGED,GWL_STYLE,(LPARAM)&ss);
-////                OSLibSetWindowStyle(getOS2WindowHandle(), getStyle(), getExStyle(),
-////                                    windowClass->getStyle() & CS_SAVEBITS);
+                OSLibSetWindowStyle(getOS2WindowHandle(), getStyle(), getExStyle());
 #ifdef DEBUG
                 PrintWindowStyle(ss.styleNew, 0);